---
title: Network request details
slug: Tools/Network_Monitor/request_details
tags:
  - '110n:priority'
  - Debugging
  - Dev Tools
  - Firefox
  - Guide
  - Networking
  - Tools
---
<p>{{ToolsSidebar}}</p>

<p>The request details pane appears when you click on a network request in the request list. This pane provides more detailed information about the request.</p>

<h2 id="Network_request_details">Network request details</h2>

<p>Clicking on a row displays a new pane in the right-hand side of the network monitor, which provides more detailed information about the request.</p>

<p><img alt="Screenshot of the Network Request details pane, without callouts for the close-pane button and the detail tabs" src="https://mdn.mozillademos.org/files/17285/Network-details-Fx78.png" style="display: block; height: 399px; margin-left: auto; margin-right: auto; width: 520px;"></p>

<div class="notecard note">
<p>The screenshots and descriptions in this section reflect Firefox 78. Earlier versions appeared similarly, but might not include some functionality.</p>
</div>

<p>The tabs at the top of this pane enable you to switch between the following pages:</p>

<ul>
 <li><strong><a href="#Headers_tab">Headers</a></strong></li>
 <li><strong>Messages</strong> (only for WebSocket items)</li>
 <li><strong><a href="#Cookies_tab">Cookies</a></strong></li>
 <li><strong><a href="#Params_tab">Params</a></strong></li>
 <li><strong><a href="#Response_tab">Response</a></strong></li>
 <li><strong><a href="#Cache_tab">Cache</a></strong></li>
 <li><strong><a href="#Timings_tab">Timings</a></strong></li>
 <li><strong><a href="#Security_tab">Security</a> </strong>(only for secure pages)</li>
 <li><strong><a href="#Stack_trace_tab">Stack trace</a></strong> (only when the request has a stack trace, e.g. a script called by another script).</li>
</ul>

<p>Clicking the icon at the right-hand end of the <a href="/en-US/docs/Tools/Network_Monitor#Toolbar">toolbar</a> closes the details pane and returns you to the list view.</p>

<h3 id="Headers_tab">Headers tab</h3>

<p>The Headers tab has a toolbar, followed by three main sections.</p>

<p>This includes:</p>

<ul>
 <li>Information about the request
  <ul>
   <li>Status: The response status code for the request; click the "?" icon to go to the reference page for the status code.</li>
   <li>Version: The version of HTTP used.</li>
   <li>Transferred: The amount of data transferred for the request.</li>
   <li>Referrer policy: The value of the <a href="/en-US/docs/Web/HTTP/Headers/Referrer-Policy">Referrer-policy header.</a></li>
  </ul>
 </li>
 <li><strong>HTTP Response headers</strong></li>
 <li><strong>HTTP Request headers</strong></li>
</ul>

<p>Each section has a disclosure triangle to expand the section to show more information.</p>

<h4 id="Headers_toolbar">Headers toolbar</h4>

<p>Using the Headers toolbar, you can:</p>

<ul>
 <li>Filter the headers in the Response Headers and Request Headers sections.</li>
 <li><strong>Block</strong> the domain involved in this request. The domain is added to the <a href="/en-US/docs/Tools/Network_Monitor/request_list#Blocking_specific_URLs">Blocking sidebar</a>.</li>
 <li>Resend the request. The <strong>Resend</strong> button opens a menu with two items:
  <ul>
   <li><strong>Resend</strong>: Resends the request.</li>
   <li><strong>Edit and Resend</strong>: Enables an editing mode, where you can modify the method, URL, request headers, or request body of the request. Click <strong>Send</strong> to send the modified request, or <strong>Cancel</strong> to cancel editing.</li>
  </ul>
 </li>
</ul>

<h4 id="Request_Information"><strong>Request Information</strong></h4>

<p>The following information is shown only when the section is expanded:</p>

<ul>
 <li><strong>Scheme</strong>: The scheme used in the URL</li>
 <li><strong>Host</strong>: The server involved in the request</li>
 <li><strong>Filename</strong>: The full path to the file requested</li>
 <li><strong>Address</strong>: The IP address of the host</li>
</ul>

<p>The following information is shown in both the collapsed and the expanded states:</p>

<ul>
 <li><strong>Status: </strong>The <a href="/en-US/docs/Web/HTTP/Status">HTTP response code</a> for the request.</li>
 <li><strong>Version</strong>: The HTTP version used</li>
 <li><strong>Transferred</strong>: The amount of data transferred with the request</li>
 <li>The <strong>Referrer Policy</strong>, which governs which referrer information, sent in the <a href="/en-US/docs/Web/HTTP/Headers/Referer" title="The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example."><code>Referer</code></a> header, should be included with requests. (See <a href="/en-US/docs/Web/HTTP/Headers/Referrer-Policy">Referrer-Policy</a> for a description of possible values)</li>
 <li><strong>Blocking</strong>: If the request is to a site that is associated with a known tracker, an icon and a message are shown; otherwise, this field is not shown.</li>
</ul>

<h4 id="Response_headers"><strong>Response headers</strong></h4>

<p>The response headers section shows details about the response. For each line in the response headers section, a question mark links to the documentation for that response header, if one is available.</p>

<p>A <strong>Raw</strong> toggle button in the section heading controls whether the headers are shown with formatting, or as plain, unformatted text.</p>

<div class="notecard note">
<p>Note that the keys in the response header are all in lowercase, while the request headers keys are not. <a href="https://tools.ietf.org/html/rfc7540#section-8.1.2">HTTP/2 requires that all headers be lowercase</a>; response headers are shown as they are received from the server. (There may be some exceptions, such as <code>X-Firefox-Spdy</code>, which is added by Firefox.)</p>
</div>

<p><img alt="Screenshot showing the Request headers section of the Request details pane" src="https://mdn.mozillademos.org/files/17287/Response-headers-Fx78.png" style="border: 1px solid black; display: block; height: 324px; margin: 0px auto; width: 523px;"></p>

<p>You can copy some or all of the response header in JSON format by using the context menu:</p>

<p><img alt='Screenshot showing the Response headers pane, and its context menu with "Copy" and "Copy all" items' src="https://mdn.mozillademos.org/files/17286/Copy-response-headers-Fx78.png" style="border: 1px solid black; display: block; height: 167px; margin: 0px auto; width: 514px;">If you select <strong>Copy</strong>, a single key word, value pair is copied. If you select <strong>Copy All</strong>, the entire header is copied in JSON format, giving you something like this (after running the results through a JSON validator):</p>

<pre class="brush: json notranslate">{
  "Response headers (1.113 KB)": {
    "headers": [
      {
        "name": "accept-ranges",
        "value": "bytes"
      },
      {
        "name": "age",
        "value": "0"
      },
      {
        "name": "backend-timing",
        "value": "D=74716 t=1560258099074460"
      },
      {
        "name": "cache-control",
        "value": "private, must-revalidate, max-age=0"
      },
      {
        "name": "content-disposition",
        "value": "inline; filename=api-result.js"
      },
      {
        "name": "content-encoding",
        "value": "gzip"
      },
      {
        "name": "content-length",
        "value": "673"
      },
      {
        "name": "content-type",
        "value": "text/javascript; charset=utf-8"
      },
      {
        "name": "date",
        "value": "Tue, 11 Jun 2019 13:01:39 GMT"
      },
      {
        "name": "mediawiki-login-suppressed",
        "value": "true"
      },
      {
        "name": "p3p",
        "value": "CP=\"This is not a P3P policy! See https://en.wikipedia.org/wiki/Special:CentralAutoLogin/P3P for more info.\""
      },
      {
        "name": "server",
        "value": "mw1316.eqiad.wmnet"
      },
      {
        "name": "server-timing",
        "value": "cache;desc=\"pass\""
      },
      {
        "name": "strict-transport-security",
        "value": "max-age=106384710; includeSubDomains; preload"
      },
      {
        "name": "vary",
        "value": "Accept-Encoding,Treat-as-Untrusted,X-Forwarded-Proto,Cookie,Authorization,X-Seven"
      },
      {
        "name": "via",
        "value": "1.1 varnish (Varnish/5.1), 1.1 varnish (Varnish/5.1)"
      },
      {
        "name": "x-analytics",
        "value": "ns=-1;special=Badtitle;WMF-Last-Access=11-Jun-2019;WMF-Last-Access-Global=11-Jun-2019;https=1"
      },
      {
        "name": "x-cache",
        "value": "cp1075 pass, cp1075 pass"
      },
      {
        "name": "x-cache-status",
        "value": "pass"
      },
      {
        "name": "x-client-ip",
        "value": "204.210.158.136"
      },
      {
        "name": "x-content-type-options",
        "value": "nosniff"
      },
      {
        "name": "X-Firefox-Spdy",
        "value": "h2"
      },
      {
        "name": "x-frame-options",
        "value": "SAMEORIGIN"
      },
      {
        "name": "x-powered-by",
        "value": "HHVM/3.18.6-dev"
      },
      {
        "name": "x-search-id",
        "value": "esvan0r5bnnwscyk2wq09i1im"
      },
      {
        "name": "x-varnish",
        "value": "766019457, 417549316"
      }
    ]
  },
  "Request headers (665 B)": {
    "headers": [
      {
        "name": "Accept",
        "value": "*/*"
      },
      {
        "name": "Accept-Encoding",
        "value": "gzip, deflate, br"
      },
      {
        "name": "Accept-Language",
        "value": "en-US,en;q=0.5"
      },
      {
        "name": "Connection",
        "value": "keep-alive"
      },
      {
        "name": "Cookie",
        "value": "WMF-Last-Access=11-Jun-2019; WMF-Last-Access-Global=11-Jun-2019; mwPhp7Seed=5c9; GeoIP=US:NY:Port_Jervis:41.38:-74.67:v4"
      },
      {
        "name": "DNT",
        "value": "1"
      },
      {
        "name": "Host",
        "value": "en.wikipedia.org"
      },
      {
        "name": "Referer",
        "value": "https://www.wikipedia.org/"
      },
      {
        "name": "TE",
        "value": "Trailers"
      },
      {
        "name": "User-Agent",
        "value": "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0"
      }
    ]
  }
}</pre>

<h4 id="Request_headers"><strong>Request</strong> headers</h4>

<p>The Request headers section shows details about the request headers. For each line in the request headers section, a question mark links to the documentation for that request header, if one is available.</p>

<p>A <strong>Raw</strong> toggle button in the section heading controls whether the headers are shown with formatting, or as plain, unformatted text.</p>

<p><img alt="Screenshot showing the Request headers section of the Request details pane" src="https://mdn.mozillademos.org/files/17288/Request-headers-Fx78.png" style="border: 1px solid black; display: block; height: 108px; margin: 0px auto; width: 523px;"></p>

<h3 id="Cookies_tab">Cookies tab</h3>

<p>This tab lists full details of any cookies sent with the request or response:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16265/network_cookies.png" style="border: 1px solid black; display: block; height: 748px; margin-left: auto; margin-right: auto; width: 2276px;"></p>

<p>As with headers, you can filter the list of cookies displayed. The full list of cookie attributes is shown—see the following screenshot showing Response cookies with further attributes shown.</p>

<p><img alt="cookies panel in firefox devtools network monitor, showing a number of cookie attributes including samesite" src="https://mdn.mozillademos.org/files/16108/highlight-samesite-attribute.png" style="display: block; height: 394px; margin: 0px auto; width: 1047px;"></p>

<p>The <code>samesite</code> attribute has been shown since Firefox 62 ({{bug("1452715")}}).</p>

<h3 id="Params_tab">Params tab</h3>

<p>This tab displays the GET parameters and POST data of a request:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16333/params.png" style="display: block; height: 215px; margin-left: auto; margin-right: auto; width: 900px;"></p>

<h3 id="Response_tab">Response tab</h3>

<p>The complete content of the response. If the response is HTML, JS, or CSS, it will be shown as text:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16268/network_response.png" style="border: 1px solid black; display: block; height: 747px; margin-left: auto; margin-right: auto; width: 900px;"></p>

<p>If the response is JSON, it will be shown as an inspectable object:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16332/response_json.png" style="display: block; height: 268px; margin: 0 auto; width: 900px;"></p>

<p>If the response is an image, the tab displays a preview:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16331/response_pane_image.png" style="display: block; height: 347px; margin-left: auto; margin-right: auto; width: 900px;"></p>

<p>For network responses that are initiated by a <a href="/en-US/docs/Web/API/WebSockets_API">WebSocket</a> connection, the details pane shows any associated messages. For more information, see <a href="/en-US/docs/Tools/Network_Monitor/Inspecting_web_sockets">Inspecting web sockets</a>.</p>

<h3 id="Cache_tab">Cache tab</h3>

<p>If the response is cached (i.e. a 304), the Cache tab displays details about that cached resource.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16329/response_cache.png" style="border: 1px solid black; display: block; height: 245px; margin: 0px auto; width: 567px;"></p>

<p>These details include:</p>

<ul>
 <li><strong>Last fetched:</strong> The date the resource was last fetched</li>
 <li><strong>Fetched count:</strong> The number of times in the current session that the resource has been fetched</li>
 <li><strong>Data size:</strong> The size of the resource.</li>
 <li><strong>Last modified:</strong> The date the resource was last modified.</li>
 <li><strong>Expires:</strong> The date the resource expires.</li>
 <li><strong>Device:</strong> The device the resource was fetched from (e.g. "disk").</li>
</ul>

<h4 id="HTML_preview">HTML preview</h4>

<p>If the response is HTML, a preview of the rendered HTML appears inside the Response tab, above the response payload.</p>

<h3 id="Timings_tab">Timings tab</h3>

<p>The Timings tab provides information about how long each stage of a network request took, with a more detailed, annotated, view of the timeline bar, so it is easy to locate performance bottlenecks.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16998/network-timings-tab.png" style="border: 1px solid black; display: block; height: 508px; margin-left: auto; margin-right: auto; width: 1000px;"></p>

<p>This tab can include the following sections.</p>

<h4 id="Queued_Started_Downloaded">Queued, Started, Downloaded</h4>

<p>New in Firefox 72, we now show the following timings at the top of the Timings tab, making dependency analysis a lot easier:</p>

<ul>
 <li>Queued: When the resource was queued for download.</li>
 <li>Started: When the resource started downloading.</li>
 <li>Downloaded: When the resource finished downloading.</li>
</ul>

<div class="notecard note">
<p><strong>Note</strong>: Future versions will also show this information when entries in the network monitor timeline graph are moused over (see {{bug(1580493)}}).</p>
</div>

<h4 id="Request_Timing">Request Timing</h4>

<p>The <em>Request Timing</em> section breaks a network request down into the following subset of the stages defined in the <a href="https://dvcs.w3.org/hg/webperf/raw-file/tip/specs/HAR/Overview.html">HTTP Archive</a> specification:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Name</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>Blocked</td>
   <td>
    <p>Time spent in a queue waiting for a network connection.</p>

    <p>The browser imposes a limit on the number of simultaneous connections that can be made to a single server. In Firefox this defaults to 6, but can be changed using the <code><a href="http://kb.mozillazine.org/Network.http.max-persistent-connections-per-server">network.http.max-persistent-connections-per-server</a></code> preference. If all connections are in use, the browser can't download more resources until a connection is released.</p>
   </td>
  </tr>
  <tr>
   <td>DNS resolution</td>
   <td>Time taken to resolve a host name.</td>
  </tr>
  <tr>
   <td>Connecting</td>
   <td>Time taken to create a TCP connection.</td>
  </tr>
  <tr>
   <td>Sending</td>
   <td>Time taken to send the HTTP request to the server.</td>
  </tr>
  <tr>
   <td>Waiting</td>
   <td>Waiting for a response from the server.</td>
  </tr>
  <tr>
   <td>Receiving</td>
   <td>Time taken to read the entire response from the server (or cache).</td>
  </tr>
 </tbody>
</table>

<h4 id="Server_Timing">Server Timing</h4>

<p>New in Firefox 71, the <em>Server Timing</em> section lists any information provided in the {{httpheader("Server-Timing")}} header — this is used to surface any backend server timing metrics you've recorded (e.g. database read/write, CPU time, file system access, etc.).</p>

<p>The header takes a series of descriptions and durations, which can be anything you like. In the above screenshot for example, the highlighted request's <code>Server-Timing</code> header contains 4 items — <em>data</em>, <em>markup</em>, <em>total</em>, and <em>miss</em>.</p>

<h3 id="Security_tab">Security tab</h3>

<p>If the site is being served over HTTPS, you get an extra tab labeled "Security". This contains details about the secure connection used including the protocol, the cipher suite, and certificate details:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16269/network_security.png" style="border: 1px solid black; display: block; height: 748px; margin-left: auto; margin-right: auto; width: 2276px;"></p>

<p>The Security tab shows a warning for security weaknesses. Currently it warns you about two weaknesses:</p>

<ol>
 <li>Using SSLv3 instead of TLS</li>
 <li>Using the RC4 cipher</li>
</ol>

<p><img alt="" src="https://mdn.mozillademos.org/files/10165/security-warning.png" style="display: block; height: 93px; margin-left: auto; margin-right: auto; width: 591px;"></p>

<h3 id="Stack_trace_tab">Stack trace tab</h3>

<p>Stack traces are shown in the <em>Stack Trace</em> tab, for responses that have a stack trace of course.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16270/network_stack_trace.png" style="border: 1px solid black; display: block; height: 205px; margin: 0px auto; width: 900px;"></p>

<h2 id="Network_Monitor_Features">Network Monitor Features</h2>

<p>The following articles cover different aspects of using the network monitor:</p>

<ul>
 <li><a href="/en-US/docs/Tools/Network_Monitor/Toolbar">Toolbar</a></li>
 <li><a href="/en-US/docs/Tools/Network_Monitor/request_list">Network request list</a></li>
 <li><a href="/en-US/docs/Tools/Network_Monitor/recording">Network traffic recording</a></li>
 <li><a href="/en-US/docs/Tools/Network_Monitor/Performance_Analysis">Performance analysis</a></li>
 <li><a href="/en-US/docs/Tools/Network_Monitor/Throttling">Throttling</a></li>
</ul>
